-- XXX TODO
-- * Unfuck the DB variables, all those globals are screwing with my mind.

local addonName = ...
local guildName = nil
local db = nil
local guildMaster = nil
local pName = UnitName("player")

local today = nil
local sessionTotal = 0
local allTimeTotal = nil
local lastTransmitTime = nil

------ Locale
local L_NAME = "Guild Money"
local L_SESSION = "This session"
local L_ALLTIME = "All time total"
local L_NOINCOME = "You haven't generated any income to your guild for the past month - stop slacking!"
local L_NOINCOME_GM = "You haven't generated any income to your guild for the past month - stop slacking! %s is very disappointed."
local L_GOODBOY = "Good boy. Once you provide some more income, daddy will give you something special."
local L_GOODBOY_GM = "Good boy. Once you provide some more income, daddy %s will give you something special."
local L_MAINCHAR = "Your main character is set to %s."
local L_TOPFIVE = "Top 5 contributors"
------

local function sortOnTotal(a, b)
	local aT = a == pName and allTimeTotal or BGMOthersDB[guildName][a]
	local bT = b == pName and allTimeTotal or BGMOthersDB[guildName][b]
	return aT > bT
end

local tmpSort = {}
local scoreFormat = "%d. %s"
local function updateTooltip(tt)
	tt:AddLine(L_NAME)
	local added = nil
	if sessionTotal > 0 then
		tt:AddDoubleLine("This session", GetCoinTextureString(sessionTotal), 1, 1, 1, 0, 1, 0)
		added = true
	end
	if db[today] and db[today] > 0 then
		tt:AddDoubleLine(HONOR_TODAY, GetCoinTextureString(db[today]), 1, 1, 1, 0, 1, 0)
		added = true
	end
	local week = 0
	for i = today, (today - 7), -1 do
		week = week + (db[i] or 0)
	end
	if week > 0 then
		tt:AddDoubleLine(CALENDAR_REPEAT_WEEKLY, GetCoinTextureString(week), 1, 1, 1, 0, 1, 0)
		added = true
	end
	local month = week
	for i = (today - 7), (today - 30), -1 do
		month = month + (db[i] or 0)
	end
	if month > 0 then
		tt:AddDoubleLine(CALENDAR_REPEAT_MONTHLY, GetCoinTextureString(month), 1, 1, 1, 0, 1, 0)
		added = true
	end
	if allTimeTotal and allTimeTotal > 0 then
		tt:AddDoubleLine(L_ALLTIME, GetCoinTextureString(allTimeTotal), 1, 1, 1, 0, 1, 0)
		added = true
	end

	wipe(tmpSort)
	tmpSort[1] = pName
	for k, v in pairs(BGMOthersDB[guildName]) do
		tmpSort[#tmpSort + 1] = k
	end
	if #tmpSort > 1 then
		added = true
		table.sort(tmpSort, sortOnTotal)
		tt:AddLine(" ")
		tt:AddLine(L_TOPFIVE)
		for i, p in next, tmpSort do
			local v = p == pName and allTimeTotal or BGMOthersDB[guildName][p]
			tt:AddDoubleLine(scoreFormat:format(i, p), GetCoinTextureString(v), 1, 1, 1, 0, 1, 0)
		end
	end

	if not added then
		if guildMaster then
			tt:AddLine(L_NOINCOME_GM:format(guildMaster), 0.2, 1, 0.2, 1)
		else
			tt:AddLine(L_NOINCOME, 0.2, 1, 0.2, 1)
		end
	else
		tt:AddLine(" ")
		if guildMaster then
			tt:AddLine(L_GOODBOY_GM:format(guildMaster), 0.2, 1, 0.2, 1)
		else
			tt:AddLine(L_GOODBOY, 0.2, 1, 0.2, 1)
		end
	end
	if BGMSettingsDB.mainChar[guildName] then
		tt:AddLine(L_MAINCHAR:format(BGMSettingsDB.mainChar[guildName]), 0.2, 1, 0.2)
	end
end

local ldb = LibStub("LibDataBroker-1.1")
local bGuildMoney = ldb:NewDataObject("Reagents", {
	type = "data source",
	icon = "Interface\\MoneyFrame\\UI-GoldIcon",
	text = L_NAME,
})

local function updateText()
	local amount = db[today] or 0
	if amount == 0 then
		bGuildMoney.text = L_NAME
	else
		local gold = floor(math.abs(amount) / 10000)
		local silver = mod(floor(math.abs(amount) / 100), 100)
		local copper = mod(floor(math.abs(amount)), 100)
		if gold ~= 0 then
			bGuildMoney.text = format("%dg%ds%dc", gold, silver, copper)
		elseif silver ~= 0 then
			bGuildMoney.text = format("%ds%dc", silver, copper)
		else
			bGuildMoney.text = format("%dc", copper)
		end
	end
end

local matchGold = GOLD_AMOUNT:gsub("%%d", "(%%d+)")
local matchSilver = SILVER_AMOUNT:gsub("%%d", "(%%d+)")
local matchCopper = COPPER_AMOUNT:gsub("%%d", "(%%d+)")
local personalMoney = YOU_LOOT_MONEY:gsub("%%s", "(.+)")
local guildMoney = YOU_LOOT_MONEY_GUILD:gsub("%(", "%%("):gsub("%)", "%%)"):gsub("%%s", "(.+)")
local guildMoneyGroup = LOOT_MONEY_SPLIT_GUILD:gsub("%(", "%%("):gsub("%)", "%%)"):gsub("%%s", "(.+)")

local function getTotalFromString(msg)
	local g = (msg:match(matchGold) or 0) * 1000
	local s = (msg:match(matchSilver) or 0) * 100
	local c = msg:match(matchCopper) or 0
	return g + s + c
end

local function scanForGM()
	for i = 1, GetNumGuildMembers(true) do
		local n, _, r = GetGuildRosterInfo(i)
		if n and r == 0 then
			if n ~= pName then guildMaster = n end
			break
		end
	end
end

_G.SlashCmdList.BGMSlash = function(input)
	if not input or input:trim():len() < 3 then return end
	BGMSettingsDB.mainChar[guildName] = input
	print(("Your main character for <%s> has been set to %q."):format(guildName, input))
end
_G.SLASH_BGMSlash1 = "/bgmmain"

local function broadcast(value)
	if not BGMSettingsDB.mainChar[guildName] then
		if BGMSettingsDB.lastLogged[guildName] and BGMSettingsDB.lastLogged[guildName] ~= pName then
			print("You need to set a main character for your guild. Please use the /bgmmain command to do so.")
			return
		end
	end
	local c = BGMSettingsDB.mainChar[guildName] or pName
	BGMSettingsDB.lastLogged[guildName] = c
	SendAddonMessage(addonName, "1#" .. c .. "#" .. tostring(value), "GUILD")
end

local function setup()
	BGMDB = BGMDB or {}
	BGMTotalDB = BGMTotalDB or {}
	BGMOthersDB = BGMOthersDB or {}
	BGMSettingsDB = BGMSettingsDB or {}
	if not BGMDB[guildName] then BGMDB[guildName] = {} end
	if not BGMTotalDB[guildName] then BGMTotalDB[guildName] = 0 end
	if not BGMOthersDB[guildName] then BGMOthersDB[guildName] = {} end
	for k, v in pairs({
		lastLogged = {},
		mainChar = {},
	}) do
		if type(BGMSettingsDB[k]) == "nil" then
			BGMSettingsDB[k] = v
		end
	end
	db = BGMDB[guildName]

	-- Borrowed from MoneyFu (probably ckk)
	local serverHour, serverMinute = GetGameTime()
	local utcHour = tonumber(date("!%H"))
	local utcMinute = tonumber(date("!%M"))
	local ser = serverHour + serverMinute / 60
	local utc = utcHour + utcMinute / 60
	local offset = floor((ser - utc) * 2 + 0.5) / 2
	if offset >= 12 then
		offset = offset - 24
	elseif offset < -12 then
		offset = offset + 24
	end
	today = floor((time() / 60 / 60 + offset) / 24)
	
	-- Anything older than 30 days is added to the total and reset
	local oneMonth = today - 30
	for k, v in pairs(db) do
		if k < oneMonth then
			BGMTotalDB[guildName] = BGMTotalDB[guildName] + v
			db[k] = nil
		end
	end
	allTimeTotal = BGMTotalDB[guildName]
	for k, v in pairs(db) do
		allTimeTotal = allTimeTotal + v
	end
	if allTimeTotal > 0 then
		broadcast(allTimeTotal)
	end

	scanForGM()
	updateText()
	bGuildMoney.OnTooltipShow = updateTooltip
end

local function attemptToSetup()
	if guildName then return true end
	guildName = GetGuildInfo("player")
	if not guildName then return end
	setup()
	return true
end

local f = CreateFrame("Frame")
f:RegisterEvent("PLAYER_LOGIN")
f:RegisterEvent("GUILD_ROSTER_UPDATE")
f:RegisterEvent("CHAT_MSG_ADDON")
f:SetScript("OnEvent", function(self, event, addon, message, channel, sender)
	if event == "PLAYER_LOGIN" or event == "PLAYER_ENTERING_WORLD" then
		if attemptToSetup() then
			self:UnregisterEvent("PLAYER_LOGIN")
			self:UnregisterEvent("PLAYER_ENTERING_WORLD")
		else
			self:RegisterEvent("PLAYER_ENTERING_WORLD")
		end
	elseif event == "GUILD_ROSTER_UPDATE" then
		attemptToSetup()
		scanForGM()
	elseif event == "CHAT_MSG_ADDON" then
		if addon ~= addonName or sender == pName then return end
		local version, player, total = strsplit("#", message)
		if tonumber(version) ~= 1 or not player or not total then return end
		local v = tonumber(total)
		if not v or v < 1 then return end
		-- Apparently CHAT_MSG_ADDON can arrive before ADDON_LOADED, so lets go.
		if not BGMOthersDB then BGMOthersDB = {} end
		if not BGMOthersDB[guildName] then BGMOthersDB[guildName] = {} end
		BGMOthersDB[guildName][player] = v
	end
end)

local function filter(self, event, msg, ...)
	-- |not db| catches failed startup
	if not db then return end
	local personal, guild = msg:match(guildMoney)
	if not guild or GetNumPartyMembers() > 0 or GetNumRaidMembers() > 0 then
		personal, guild = msg:match(guildMoneyGroup)
	end
	if not guild then return end

	local looted = (getTotalFromString(guild) or 0)
	sessionTotal = sessionTotal + looted
	db[today] = (db[today] or 0) + looted
	allTimeTotal = allTimeTotal + looted

	local t = GetTime()
	if not lastTransmitTime or (t > lastTransmitTime + 120) then
		broadcast(allTimeTotal)
		lastTransmitTime = t
	end

	updateText()

	local t = GetCoinTextureString(getTotalFromString(personal))
	return false, YOU_LOOT_MONEY:format(t) .. ".", ...
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_MONEY", filter)

